\subsection{Example 5 - Custom GPIO driver}
## Example 5 - GPIO on RedPitaya, the right way

> Create a custom driver for setting default GPIO states.

1. Create a new module for setting default states
   of chosen GPIO pins. Get inspired by the `leds-gpio.c`
2. Use device tree source from last step, remove user leds
   0 and 1 and use those pins for node "gpio-default"
3. Build and load the module and device tree binary to the
   RedPitaya
4. Boot the board and check results

## Example 5 - DevTree structure

```C
gpio-default {
		compatible = "gpio-defaults";

		pin1 {
			gpios = <&gpio0 58 0>;
			default-state = "off";
		};

		pin2 {
			gpios = <&gpio0 59 0>;
			default-state = "off";
		};
	};
```
