#include <linux/module.h>    /* For all kernel modules */
#include <linux/kernel.h>    /* KERN_INFO */
#include <linux/init.h>      /* __init and __exit macros */

static int loops = 0;
static char *text = NULL;

/* Specify Meta information */
MODULE_LICENSE("GPL");
MODULE_AUTHOR("Lukas Janik");
MODULE_DESCRIPTION("Our first module - with params");

static int __init first_module_init(void)
{
	int i;

    printk(KERN_INFO "Our first module with params loaded!\n");

    if (text != NULL) {
    	for (i=0; i<loops; i++) {
    		printk("%d: %s\n", i, text);
    	}
    }

    return 0;
}

static void __exit first_module_cleanup(void)
{
    printk(KERN_INFO "Our first module with params is cleaning up\n");
}

module_init(first_module_init);
module_exit(first_module_cleanup);

/* Integer parameter */
module_param(loops, int, S_IRUGO);

/* Char pointer (string) parameter */
module_param(text, charp, S_IRUGO);